<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <title>Smart License</title>
</head>

<body>
    <h1 class="text-center">Smart Licensing</h1>
    <div class="container">
        <div class="d-flex justify-content-between">
        <div>
            <div class="form-group">
                <label for="va">Licensing Account:&nbsp;</label>
                <select name="va" id="va" class="form-control d-inline" style="width: 140px; height: 35px;">
                    <option value="off" selected>Off Net CPE</option>
                    <option value="on">On Net CPE</option>
                </select>
            </div>
            <div class="form-group ml-1 mb-4">
                <input type="radio" name="reg_rev" id="reg" value="reg" checked class="form-check-inline"><label for="reg"
                    class="form-check-label mr-4">Register</label>
                <input type="radio" name="reg_rev" id="rev" value="rev" class="form-check-inline"><label for="rev"
                    class="form-check-label">Revoke</label>
            </div>
            <div id="sus_div" class="alert alert-success" style="display: none;">
                <!-- <button type="button" class="close" data-dismiss="alert">&times;</button> -->
            </div>
            <div id="err_div" class="alert alert-danger" style="display: none;">
                <!-- <button type="button" class="close" data-dismiss="alert">&times;</button> -->
            </div>
        </div>
        
        <div>
            <br><br><br>
            <button type="button" class="btn btn-sm btn-secondary mr-3" style="display: none;"
            id="update_t">Update Token</button>
        </div>
    </div>
        <hr>
        <div class="mt-3">
            <div id="err_msg" class="alert alert-dark alert-dismissible" style="display: none;">
                <button type="button" class="close" data-dismiss="alert">&times;</button>
                <!-- <strong>No available token found!</strong> Please upload one below: -->
            </div>
            <div id="una_msg" class="alert alert-dark alert-dismissible" style="display: none;">
                <button type="button" class="close" data-dismiss="alert">&times;</button>
                <strong>No available token found!</strong> Please upload one below:
            </div>
            <div id="suc_msg" class="alert alert-dark alert-dismissible" style="display: none;">
                <button type="button" class="close" data-dismiss="alert">&times;</button>
                <strong>Token uploaded successfully!</strong> Please continue:
            </div>
            <div id="ava_msg" class="alert alert-dark alert-dismissible" style="display: none;">
                <button type="button" class="close" data-dismiss="alert">&times;</button>
                <strong>Available token found!</strong> Please continue:
            </div>
        </div>
        <div id="devi_info">
            Number of Device(s):
            <input type="number" name="num_devi" id="num_devi" min="1" value="1" class="form-control d-inline"
                style="width: 65px; height: 30px;">
            <div id="inps" class="text-center">
                <div class="ip_div">
                    <input type="text" placeholder="X.X.X.X" class="ip_inp form-control w-25 mx-auto d-inline">
                </div>
            </div>
            <br><br>
            <div id="reg_btn_div" class="d-flex justify-content-end">
                <button type="button" class="btn btn-block btn-outline-secondary"
                    id="reg_btn">
                    Register</button>
            </div>
        </div>
        <div class="text-center">
            <input type="button" id="check_t_btn" class="btn btn btn-outline-secondary mt-2" value="Check Token Availability"
                style="display: none;">
        </div>
        <div id="t_info" style="display: none;">
            <label for="t_msg">Token:</label>
            <!-- <span id="t_msg" class="text-danger" style="display: none;"><br>&nbsp;&nbsp;* Required</span><br> -->
            <textarea name="t" id="t" cols="25" rows="5" placeholder="Paste an on-net registration token here" class="form-control w-50"></textarea><br>
            <label for="days_msg">Expires After Days:</label>
            <!-- <span id="days_msg" class="text-danger" style="display: none;"><span>&nbsp;&nbsp;* Invalid</span><br> -->
            <input type="number" name="e_days" id="e_days" placeholder="30" class="form-control" style="width: 120px"><br>
            <div  class="d-flex justify-content-end">
                <input type="button" value="Update" id="update_btn" class="btn btn-block btn-outline-secondary mr-5">
            </div>
        </div>
    </div>

    <div id="test"></div>


    <script>
        let ipRegex = /^\d{1,4}(.\d{1,4}){3}$/;
        let r_token_on;

        // render result with 'SUCCESS' status
        function renderResultWhenSusSta(result) {
            console.log(result);
            $("#sus_div").empty();
            $("#err_div").empty();
            $("#sus_div, #err_div").hide();

            if (result['success'].length > 0) {
                let liObj = $('<ul></ul>');
                for (let i = 0; i < result['success'].length; i++) {
                    liObj.append(`<li>${result['success'][i][0]}: ${result['success'][i][1]}</li>`);
                }
                $("#sus_div").append(liObj);
                $("#sus_div").show();
            }

            if (result['failure'].length > 0) {
                let liObj = $('<ul></ul>');
                for (let i = 0; i < result['failure'].length; i++) {
                    liObj.append(`<li>${result['failure'][i][1]}</li>`);
                }
                $("#err_div").append(liObj);
                $("#err_div").show();
            }
        }

        $(document).ready(function () {
            $("#va").change(function () {
                $("#update_t, #una_msg, #err_msg, #ava_msg, #suc_msg, #t_info, #sus_div, #err_div").hide();
                $(".ip_inp, #t, #e_days").removeClass('is-invalid');
                if ($(this).val() == 'off') {
                    $("#check_t_btn").hide();
                    $("#devi_info").show();
                }
                if ($(this).val() == 'on') {
                    $("#devi_info").hide();
                    $("#check_t_btn").show();
                }
                $("#num_devi").val(1);
                $(".ip_inp").val('');
                let ipInpObj = $("#inps").children()[0];
                $("#inps").empty();
                $("#inps").append(ipInpObj);
            });

            $(":radio").change(function () {
                if ($(this).val() == 'reg') {
                    $("#reg_btn").text('Register');
                }
                else {
                    $("#reg_btn").text('Revoke');
                }
            });

            $("#check_t_btn").click(function () {
                $.ajax({
                    type: 'POST',
                    url: '/checkOnToken',
                    cache: false,
                    success: function (result) {
                        $("#check_t_btn").hide();
                        if (result['status'] == 'SUCCESS') {

                            // global
                            r_token_on = result['token'];
                            console.log(r_token_on);
                            $("#update_t, #ava_msg, #devi_info").show();
                        }
                        else {
                            $("#una_msg, #t_info").show();
                        }
                    }
                });
            });

            $("#update_btn").click(function () {
                let token = $("#t").val();
                let days = $("#e_days").val();
                if (!token) {
                    $("#t").addClass('is-invalid');
                    $("#t").change(function() {
                        if ($(this).val()) {
                            $(this).removeClass('is-invalid');
                        } else {
                            $(this).addClass('is-invalid');
                        }
                    });
                } else {
                    $("#t").removeClass('is-invalid');
                }
                if (!days || days <= 0) {
                    $("#e_days").addClass('is-invalid');
                    $("#e_days").change(function() {
                        if ($(this).val()) {
                            $(this).removeClass('is-invalid');
                        } else {
                            $(this).addClass('is-invalid');
                        }
                    });
                } else {
                    $("#e_days").removeClass('is-invalid');
                }

                if (token && days > 0) {
                    $.ajax({
                        type: 'POST',
                        url: '/updateOnToken',
                        contentType: 'application/json',
                        data: JSON.stringify({
                            token: token,
                            days: days
                        }),
                        cache: false,
                        success: function (result) {
                            if (result['status'] == "SUCCESS") {

                                // global
                                r_token_on = result['token'];
                                console.log(r_token_on);
                                $("#una_msg, #t_info").hide();
                                $("#update_t, #suc_msg, #devi_info").show();
                            }
                        }
                    });
                }
            });

            $("#update_t").click(function () {
                $("#devi_info, #una_msg, #ava_msg, #suc_msg").hide();
                $("#t_info").show();
                $("#t, #e_days").val('');
                $("#t, #e_days").removeClass('is-invalid');
            });

            $("#num_devi").change(function () {
                $(".ip_inp").removeClass('is-invalid');
                let numOfInps = $(this).val();
                if (numOfInps < 1) {
                    $(this).val(1);
                    return;
                }
                let preNumOfInps = $(".ip_inp").length;
                let diff = numOfInps - preNumOfInps;
                if (diff > 0) {
                    for (let i = 0; i < diff; i++) {
                        let newInp = `
                        <div class="ip_div">
                            <input type="text" placeholder="X.X.X.X" class="ip_inp form-control w-25 mx-auto">
                        </div>`;
                        $("#inps").append(newInp);
                    }
                }
                else if (diff < 0) {
                    for (let i = 0; i < -diff; i++) {
                        $("#inps").children().last().remove();
                    }
                }
            });
        });

        $("#reg_btn").click(function () {
            $("#sus_div, #err_div").hide();

            let ipInps = $(".ip_inp");
            let ips = [];
            for (let i = 0; i < ipInps.length; i++) {
                let ip = ipInps[i].value;
                if (!ipRegex.test(ip)) {
                    $(ipInps[i]).addClass('is-invalid');
                    $(ipInps[i]).change(function() {
                        if (ipRegex.test($(this).val())) {
                            $(this).removeClass('is-invalid');
                        } else {
                            $(this).addClass('is-invalid');
                        }
                    });
                }
                else {
                    $(ipInps[i]).removeClass('is-invalid')
                    ips.push(ip);
                }
            }
            if (ips.length < ipInps.length) {
                return;
            }

            let regBtnVal = $(this).text();
            let loadingVal;
            if (regBtnVal.includes('Register')) {
                loadingVal = 'Registering... ';
            } else {
                loadingVal = 'Revoking... ';
            }
            $(this).html(loadingVal + '<span class="spinner-border spinner-border-sm"></span>');
            $(this).prop('disabled', true);
            $("#va").prop('disabled', true);
            $(":radio").prop('disabled', true);
            $("#num_devi").prop('disabled', true);

            if (ips) {
                let radChecked = $("input[name='reg_rev']:checked").val();
                if ($("select").val() == 'off') {
                    let url;
                    if (radChecked == 'reg') {
                        url = '/registerOff'
                    }
                    if (radChecked == 'rev') {
                        url = '/revokeOff'
                    }
                    $.ajax({
                        type: 'POST',
                        url: url,
                        contentType: 'application/json',
                        data: JSON.stringify({
                            ips: ips
                        }),
                        cache: false,
                        success: function (result) {
                            if (result['status'] == 'SUCCESS') {
                                renderResultWhenSusSta(result);
                            }
                            if (result['status']=='ERROR') {
                                $("#err_msg").append(`<strong>${result['error']}!</strong> ${result['message']}`);
                                $("#err_msg").show();
                            }
                            $("#reg_btn").text(regBtnVal);
                            $("#reg_btn").prop('disabled', false);
                            $("#va").prop('disabled', false);
                            $(":radio").prop('disabled', false);
                            $("#num_devi").prop('disabled', false);
                        },
                        error: function (e) {
                            $("#err_msg").text(e);
                            $("#reg_btn").text(regBtnVal);
                            $("#reg_btn").prop('disabled', false);
                            $("#va").prop('disabled', false);
                            $(":radio").prop('disabled', false);
                            $("#num_devi").prop('disabled', false);
                        }
                     
                    });
                }
                if ($("select").val() == 'on') {
                    let url;
                    let data;
                    console.log(r_token_on);
                    if (radChecked == 'reg') {
                        url = '/registerOn';
                        data = JSON.stringify({
                            ips: ips,
                            r_token: r_token_on
                        });
                    }
                    if (radChecked == 'rev') {
                        url = '/revokeOn';
                        data = JSON.stringify({
                            ips: ips
                        });
                    }
                    $.ajax({
                        type: 'POST',
                        url: url,
                        contentType: 'application/json',
                        data: data,
                        cache: false,
                        success: function (result) {
                            if (result['status'] == 'SUCCESS') {
                                renderResultWhenSusSta(result);
                            }
                            $("#reg_btn").text(regBtnVal);
                            $("#reg_btn").prop('disabled', false);
                            $("#va").prop('disabled', false);
                            $(":radio").prop('disabled', false);
                            $("#num_devi").prop('disabled', false);
                        }
                    });
                }
            }
            console.log(ips);
        });
    </script>
</body>

</html>